/**
 * @license
 * Copyright (c) 2020 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
"use strict";var _fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_serialport=_interopRequireDefault(require("serialport")),_enocean=require("./lib/enocean"),_eep_handlers=require("./lib/eep_handlers");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const ENOCEAN_LEARN_MODE_TIMEOUT=parseInt(process.env.ENOCEAN_LEARN_MODE_TIMEOUT)||18e5,ENOCEAN_LEARN_MODE_THRESHOLD_MS=parseInt(process.env.ENOCEAN_LEARN_MODE_THRESHOLD_MS)||2e3,ENOCEAN_LEARN_MODE_THRESHOLD_RSSI=parseInt(process.env.ENOCEAN_LEARN_MODE_THRESHOLD_RSSI)||47;let learnedIDs=null;module.exports=function(e){class n{constructor(t){e.nodes.createNode(this,t);try{this.serialPort=t.serialPort,n.pool.add(this)}catch(n){this.error(e._("enocean.errors.serialPortError",{error:n}))}}}function t(){return _path.default.join(e.settings.userDir,"enocean-ids.json")}function r(i){let o=n.pool.get(i.enoceanPortNode.serialPort);isNaN(i.originatorIdInt)?(i.learning=!0,i.learningCount=0,i.learnEventAt=0,i.learningTimeout&&clearTimeout(i.learningTimeout),i.learningTimeout=setTimeout(()=>{i.emit("timeout")},ENOCEAN_LEARN_MODE_TIMEOUT),o.port.on("learn",n=>{i.learning&&n.container.dBm<=ENOCEAN_LEARN_MODE_THRESHOLD_RSSI&&i.isValidLearnPacket(n,i.ignoreLRNBit)?(0===i.learningCount&&(i.learnEventAt=Date.now()),Date.now()-i.learnEventAt<=ENOCEAN_LEARN_MODE_THRESHOLD_MS?(++i.learningCount,i.learningCount>=i.learningThresholdCount&&(i.originatorId=n.originatorId,i.originatorIdInt=n.originatorIdInt,isNaN(i.originatorIdInt)||(!function(e){let n=e.id;learnedIDs||(learnedIDs={}),learnedIDs[n]=e.originatorId,_fs.default.writeFile(t(),JSON.stringify(learnedIDs),n=>{n&&e.error("Failed to write detected OriginatorID!",n)})}(i),r(i)))):(i.learningCount=0,i.learnEventAt=0)):i.showEnOceanWarning&&i.warn(e._("enocean.warn.noNode",{originatorId:n.originatorId}))})):(i.learning=!1,o.port.on(`ctx-${i.originatorIdInt}`,n=>{let t=_eep_handlers.ERP2_HANDLERS[i.eepType];if(!t)return void(i.showEnOceanWarning&&i.warn(e._("enocean.warn.noHandler",{eepType:i.eepType})));let r=t(n);r.tstamp=Date.now(),r.rssi=n.container.dBm,r.id=n.originatorId,i.addEepType&&(r.eep=i.eepType),i.useString&&(r=JSON.stringify(r));let o=`${i.eepType}/${r.id}`;i.send({topic:o,payload:r})}),i.learningTimeout&&(clearTimeout(i.learningTimeout),delete i.learningTimeout),i.emit("learned"))}n.pool=new _enocean.SerialPool(e),e.nodes.registerType("EnOcean Port",n);e.nodes.registerType("EnOcean in",class{constructor(i){if(e.nodes.createNode(this,i),this.name=i.name,this.alwaysStartAsLearningMode=i.alwaysStartAsLearningMode||!1,this.originatorId=i.originatorId,i.originatorId||i.alwaysStartAsLearningMode||(this.originatorId=function(e){if(!learnedIDs)try{let e=_fs.default.readFileSync(t());learnedIDs=JSON.parse(e)}catch(e){learnedIDs={}}return learnedIDs[e]}(this.id)),this.originatorIdInt=parseInt(this.originatorId,16),this.eepType=i.eepType,this.addEepType=i.addEepType,this.useString=i.useString,this.showEnOceanWarning=i.showEnOceanWarning||!0,this.enoceanPortNodeId=i.enoceanPort,this.enoceanPortNode=e.nodes.getNode(this.enoceanPortNodeId),this.ignoreLRNBit=i.ignoreLRNBit||!1,this.learning=!1,this.eepType){let e=this.eepType.substring(0,2);switch(e){case"f6":this.learningThresholdCount=2;break;case"d5":case"a5":this.learningThresholdCount=1;break;default:this.learningThresholdCount=1}this.isValidLearnPacket=_eep_handlers.ERP2_TEACH_IN_HANDLERS[e]}this.status({}),this.on("learned",()=>{this.learning=!1,this.status({fill:"green",shape:"dot",text:"node-red:common.status.connected"}),this.warn(e._("enocean.warn.learned",{name:this.name||this.id,originatorId:this.originatorId}))}),this.on("timeout",()=>{this.learning=!1,this.status({fill:"red",shape:"ring",text:"enocean.status.timeout"})}),this.on("close",e=>{this.enoceanPortNode?n.pool.close(this.enoceanPortNode.serialPort).then(()=>{e()}):e()});try{let e=n.pool.get(this.enoceanPortNode.serialPort);e.port.on("ready",()=>{r(this),this.learning&&this.status({fill:"blue",shape:"dot",text:"enocean.status.learning"})}),e.port.on("closed",()=>{this.status({fill:"red",shape:"ring",text:"node-red:common.status.not-connected"})})}catch(n){this.error(e._("enocean.errors.serialPortError",{error:n}))}}}),e.httpAdmin.get("/eeps",e.auth.needsPermission("eep.read"),(function(e,n){n.json(Object.keys(_eep_handlers.ERP2_HANDLERS))})),e.httpAdmin.get("/enoceanports",e.auth.needsPermission("serial.read"),(function(e,n){let t=[];_fs.default.stat("/dev/enocean",e=>{e||t.push({comName:"/dev/enocean"}),_serialport.default.list((function(e,r){n.json(t.concat(r))}))})}))};
//# sourceMappingURL=enocean.js.map
