/**
 * @license
 * Copyright (c) 2020 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.SerialPool=void 0;var _serialport=_interopRequireDefault(require("serialport")),_serialportEnoceanParser=_interopRequireDefault(require("serialport-enocean-parser")),_esp3_erp2_parser=require("./esp3_erp2_parser"),_fs=_interopRequireDefault(require("fs"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const ESP3_PACKET_PARSERS={10:new _esp3_erp2_parser.ESP3RadioERP2Parser};class ESP3PacketParser{constructor(e){this.RED=e}parse(e){return new Promise((r,o)=>{let a=ESP3_PACKET_PARSERS[e.header.packetType];if(a)r({parser:a,payload:e.getRawBuffer()});else{let r=Error("enocean.warn.unsupportedPacketType");r.packetType=e.header.packetType,o(r)}})}}exports.SerialPool=class{constructor(e){this.pool={},this.esp3PacketParser=new ESP3PacketParser(e),this.erp2Parser=new _esp3_erp2_parser.ERP2Parser,this.RED=e}add(e){let r=this,o=e.serialPort;if(!o)throw Error("serialPort property is missing!");if(!_fs.default.existsSync(o))throw Error(`The port [${o}] is NOT ready!`);if(r.pool[o])throw Error(`The serial port [${o}] is duplicate!`);let a=new _serialport.default(o,{baudRate:57600});a.on("open",()=>{a.emit("ready")}),a.on("data",o=>new Promise(e=>{(0,_serialportEnoceanParser.default)({emit:(r,o)=>e(o)},o)}).then(o=>r.esp3PacketParser.parse(o).then(o=>{o.parser.parse(o.payload).then(o=>{r.erp2Parser.parse(o).then(e=>{let r=e.originatorIdInt;a.emit(`ctx-${r}`,e)||a.emit("learn",e)}).catch(a=>{e.error(r.RED._("enocean.errors.parseError",{error:a,data:JSON.stringify(o)}))})}).catch(a=>{e.error(r.RED._("enocean.errors.parseError",{error:a,data:o.payload}))})})).catch(a=>{a instanceof Error&&"enocean.warn.unsupportedPacketType"===a.message?e.showEnOceanWarning&&e.warn(r.RED._("enocean.warn.unsupportedPacketType",{packetType:a.packetType})):e.error(r.RED._("enocean.errors.parseError",{error:a,data:JSON.stringify(o)}))})),a.on("error",a=>{e.warn(r.RED._("enocean.errors.serialPortError",{error:a})),delete r.pool[o]}),a.on("disconnect",()=>{e.debug(r.RED._("enocean.debug.serialPortDisconnected",{portName:o})),delete r.pool[o]}),a.on("close",()=>{e.debug(r.RED._("enocean.debug.serialPortClosed",{portName:o})),delete r.pool[o]}),r.pool[o]={node:e,port:a},e.debug(r.RED._("enocean.debug.serialPortAdded",{portName:o}))}get(e){let r=this.pool[e];if(!r)throw Error(`The given port ${e} is missing!`);return r}close(e){let r=this,o=r.pool[e];return new Promise(a=>{o?(delete r.pool[e],o.port.close(()=>{a()})):a()})}};
//# sourceMappingURL=enocean.js.map
