/**
 * @license
 * Copyright (c) 2020 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ESP3RadioERP2Parser=exports.ERP2Parser=void 0;const CRC8_TABLE=[0,7,14,9,28,27,18,21,56,63,54,49,36,35,42,45,112,119,126,121,108,107,98,101,72,79,70,65,84,83,90,93,224,231,238,233,252,251,242,245,216,223,214,209,196,195,202,205,144,151,158,153,140,139,130,133,168,175,166,161,180,179,186,189,199,192,201,206,219,220,213,210,255,248,241,246,227,228,237,234,183,176,185,190,171,172,165,162,143,136,129,134,147,148,157,154,39,32,41,46,59,60,53,50,31,24,17,22,3,4,13,10,87,80,89,94,75,76,69,66,111,104,97,102,115,116,125,122,137,142,135,128,149,146,155,156,177,182,191,184,173,170,163,164,249,254,247,240,229,226,235,236,193,198,207,200,221,218,211,212,105,110,103,96,117,114,123,124,81,86,95,88,77,74,67,68,25,30,23,16,5,2,11,12,33,38,47,40,61,58,51,52,78,73,64,71,82,85,92,91,118,113,120,127,106,109,100,99,62,57,48,55,34,37,44,43,6,1,8,15,26,29,20,19,174,169,160,167,178,181,188,187,150,145,152,159,138,141,132,131,222,217,208,215,194,197,204,203,230,225,232,239,250,253,244,243],LONG_DATA_ID_IDX=[[3,0],[4,0],[4,4],[6,0]],TELEGRAM_TYPES={0:["RPS",246],1:["1BS",213],2:["4BS",165],3:["Smart Acknowledge Signal",208],4:["VDL",210],5:["Universal Teach-In EEP",212],6:["MSC",209],7:["SEC",48],8:["SEC_ENCAPS",49],9:["Secure Teach-In telegram for switch",53],10:["Generic Profiles selective data",179],11:["reserved"],12:["reserved"],13:["reserved"],14:["reserved"],15:["Extended Telegram type available"]},ESP3_DUMP=process.env.ESP3_DUMP||!1;Uint8Array.prototype.slice||(Uint8Array.prototype.slice=Array.prototype.slice);class Utils{static pad(r,e,t){return t=t||"0",(r+="").length>=e?r:Array(e-r.length+1).join(t)+r}static crc8(r,e){return CRC8_TABLE[r^e]}}class ERP2Parser{parse(r){let e,t,o,a;if("object"==typeof r&&r.payload&&ERP2Parser.isArray(r.payload))t=r.payload,a=r;else if("string"==typeof r)t=new Uint8Array(Buffer.from(r,"hex"));else if(ERP2Parser.isArray(r))t=r;else{if(!(r instanceof Buffer))throw Error("Unsupported ERP2 payload data type!");t=new Uint8Array(r)}return o=(e=t.length)<=6?this._doParseShort(e,t,a):this._doParseLong(e,t,a)}static isArray(r){return r instanceof Array||r instanceof Uint8Array}_doParseShort(r,e,t){return new Promise((o,a)=>{try{let a,i={len:r,payload:e,originatorId:""},n=r-1,s=1;for(1===r?(i.originatorId=Utils.pad(e[0].toString(16),2),s=0):r>=6&&(n=4,s=2),a=0;a<n;a++)i.originatorId+=Utils.pad(e[a].toString(16),2);for(i.originatorIdInt=parseInt(i.originatorId,16),a=0;a<s;a++)i.dataDl+=Utils.pad(e[a+n].toString(16),2);t&&(i.container=t),o(i)}catch(r){a(r)}})}_doParseLong(r,e,t){return new Promise((o,a)=>{try{let a=e[0]>>5;if(!LONG_DATA_ID_IDX[a])throw Error("Reserved address is unsupported");let i,n={len:r,payload:e,originatorId:"",destinationId:""},s=LONG_DATA_ID_IDX[a][0],l=LONG_DATA_ID_IDX[a][1];for(i=0;i<s;i++)n.originatorId+=Utils.pad(e[i+1].toString(16),2);for(i=0;i<l;i++)n.destinationId+=Utils.pad(e[i+s+1].toString(16),2);if(n.originatorIdInt=parseInt(n.originatorId,16),(16&e[0])>>4>0)throw Error("Extended header is unsuported");let d=15&e[0];if(15===d)throw Error("Extended Telegram type is unsuported");n.telegramType=TELEGRAM_TYPES[d][0],n.rorg=TELEGRAM_TYPES[d][1],n.dataDl=e.slice(s+l+1,e.length-1);let c=0;for(i=0;i<e.length-1;i++)c=Utils.crc8(c,e[i]);if(c!==e[e.length-1])throw Error("CRC8 checksum failure");t&&(n.container=t),o(n)}catch(r){a(r)}})}}exports.ERP2Parser=ERP2Parser;exports.ESP3RadioERP2Parser=class{parse(r){let e,t;if("string"==typeof r)t=new Uint8Array(Buffer.from(r,"hex"));else if(r instanceof Array)t=r;else{if(!(r instanceof Buffer))throw Error("Unsupported ESP3 payload data type!");t=new Uint8Array(r)}return e=t.length,ESP3_DUMP&&console.log(`ENOCEAN LEN[${e}] RAW[${Buffer.from(t).toString("hex")}]`),new Promise((r,o)=>{try{if(85!==t[0])throw Error("Unknown Synchronization-word");if(10!==t[4])throw Error("Invalid packet type, RADIO_ERP2(0x0a) is expected");if(2!==t[3])throw Error("Invalid optinal size");let o,a=0,i=t.slice(1,5);for(o=0;o<i.length;o++)a=Utils.crc8(a,i[o]);if(a!==t[5])throw Error("CRC8 for header value checksum failure");let n={len:e},s=256*t[1]+t[2];for(n.payload=t.slice(6,6+s),n.subTelNum=t[6+s],n.dBm=t[7+s],a=0,o=0;o<s+2;o++)a=Utils.crc8(a,t[o+6]);if(a!==t[t.length-1])throw Error("CRC8 for data value checksum failure");r(n)}catch(r){o(r)}})}};
//# sourceMappingURL=esp3_erp2_parser.js.map
