"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.CandyRed=void 0,require("source-map-support/register");var _http=_interopRequireDefault(require("http")),_request=_interopRequireDefault(require("request")),_express=_interopRequireDefault(require("express")),_nodeRed=_interopRequireDefault(require("node-red")),_os=_interopRequireDefault(require("os")),_fs=_interopRequireDefault(require("fs")),_mkdirp=_interopRequireDefault(require("mkdirp")),_compression=_interopRequireDefault(require("compression")),_deviceManager=_interopRequireDefault(require("./device-manager")),_auth=require("./auth");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}
/**
 * @license
 * Copyright (c) 2020 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const PORT=process.env.PORT||8100,DEFAULT_PACKAGE_JSON=__dirname+"/../package.json",DEFAULT_WELCOME_FLOW=__dirname+"/welcome-flow.json",NODE_PALETTE_ENABLED=!!process.env.NODE_PALETTE_ENABLED&&"true"===process.env.NODE_PALETTE_ENABLED,NODE_RED_PROJECTS_ENABLED=!!process.env.NODE_RED_PROJECTS_ENABLED&&"true"===process.env.NODE_RED_PROJECTS_ENABLED,CANDY_RED_SESSION_TIMEOUT=parseInt(process.env.CANDY_RED_SESSION_TIMEOUT||86400),CANDY_RED_ADMIN_USER_ID=process.env.CANDY_RED_ADMIN_USER_ID,CANDY_RED_ADMIN_PASSWORD_ENC=process.env.CANDY_RED_ADMIN_PASSWORD_ENC,CANDY_RED_LOG_LEVEL=process.env.CANDY_RED_LOG_LEVEL||"info",CANDY_RED_BIND_IPV4_ADDR=!!process.env.CANDY_RED_BIND_IPV4_ADDR&&"true"===process.env.CANDY_RED_BIND_IPV4_ADDR,NODE_ENV=process.env.NODE_ENV||"";class CandyRed{constructor(e){this.app=(0,_express.default)(),this.server=_http.default.createServer(this.app),this.deviceManager=new _deviceManager.default,this.packageJsonPath=e,this.flowFile="flows_candy-red.json"}_migrateFlowFile(e){return new Promise((t,r)=>{if(!this.flowFile)return r(Error("Missing this.flowFile!"));if("cred"===_os.default.hostname())return t();let s=`${e}/${this.flowFile}`,i=`${e}/flows_candy-red_${_os.default.hostname()}.json`;_fs.default.rename(i,s,r=>{if(r){let r=`${e}/flows_candy-box_${_os.default.hostname()}.json`;_fs.default.rename(r,s,e=>{e||console.log(`[CANDY RED] {MIGRATED} ${r} => ${s}`),t()})}else console.log(`[CANDY RED] {MIGRATED} ${i} => ${s}`),t()})})}_prepareWelcomeFlowFileReadStream(){return new Promise((e,t)=>{let r=process.env.WELCOME_FLOW_URL;if(r&&(r.indexOf("http://")||r.indexOf("https://"))){let s=_request.default.get(r);return s.on("error",()=>{try{return e(_fs.default.createReadStream(DEFAULT_WELCOME_FLOW))}catch(e){return t(e)}}),e(s)}try{return e(_fs.default.createReadStream(DEFAULT_WELCOME_FLOW))}catch(e){return t(e)}})}_prepareDefaultFlowFile(e){return new Promise((t,r)=>{_fs.default.stat(e,s=>(s&&(0,_mkdirp.default)(e,e=>e?r(e):t()),t()))}).then(()=>new Promise((t,r)=>{let s=`${e}/${this.flowFile}`;_fs.default.stat(s,e=>{if(!e)return t();this._prepareWelcomeFlowFileReadStream().then(e=>{let i=_fs.default.createWriteStream(s);e.pipe(i),i.on("close",()=>{_fs.default.readFile(s,(e,i)=>{if(e)return r(e);try{JSON.parse(i),console.log("[CANDY RED] Default welcome flow has been created"),t()}catch(e){_fs.default.writeFile(s,"[]",{flag:"w"},e=>{if(e)return r(e);console.log("[CANDY RED] {WARN} Wrong JSON format in thhe welcome flow"),t()})}})})}).catch(e=>{r(e)})})}))}start(){return CANDY_RED_BIND_IPV4_ADDR?this.server.listen(PORT,"0.0.0.0"):this.server.listen(PORT),this._setupExitHandler(),this._inspectBoardStatus(this.packageJsonPath).then(e=>new Promise((t,r)=>{let s=this._createREDSettigngs(e);this._migrateFlowFile(s.userDir).then(()=>this._prepareDefaultFlowFile(s.userDir)).then(()=>{t([s,e])}).catch(e=>{r(e)})})).then(e=>{let t=e[0],r=e[1];_nodeRed.default.init(this.server,t),this.app.use((0,_compression.default)()),this.app.use(t.httpNodeRoot,_nodeRed.default.httpNode);const s=t.userDir+"/"+this.flowFile;return this.deviceManager.initWithFlowFilePath(s).then(()=>this.deviceManager.initDeviceManagement(t)).then(e=>(_nodeRed.default.log.info(`[CANDY RED] Headless Enabled? => ${e}`),e||(_nodeRed.default.log.info("[CANDY RED] Deploying Flow Editor UI..."),this.app.use("/",_express.default.static(__dirname+"/public")),t.httpAdminRoot&&this.app.get("/",(e,r)=>{r.redirect(t.httpAdminRoot)}),this.app.use(t.httpAdminRoot,_nodeRed.default.httpAdmin)),_nodeRed.default.start())).then(()=>{t.version+=` [candy-red v${r.candyRedv}]`,_nodeRed.default.log.info(`[CANDY RED] Listen port=${PORT}`)})})}_createCandyRedEditorTheme(e){let t=_os.default.hostname(),r=t;return e&&(t=e,r=`${_os.default.hostname()} (${t})`),{palette:{editable:NODE_PALETTE_ENABLED},projects:{enabled:NODE_RED_PROJECTS_ENABLED},page:{title:"CANDY RED@"+t,favicon:__dirname+"/public/images/candy-red.ico",css:__dirname+"/public/css/candy-red.css"},header:{title:" ** "+r+" **",image:__dirname+"/public/images/candy-red.png"},login:{image:__dirname+"/public/images/logo.png"},menu:{"menu-item-help":{label:"Users Forum",url:"https://forums.candy-line.io/c/candy-red"},"menu-item-keyboard-shortcuts":!0}}}_inspectBoardStatus(e){return this.deviceManager.testIfCANDYBoardServiceInstalled().then(t=>(this.editorTheme=this._createCandyRedEditorTheme(t),t=t||"N/A",new Promise((t,r)=>{_fs.default.stat(e,s=>s?r(s):t(e))}).then(e=>new Promise(r=>{_fs.default.readFile(e,(e,s)=>{if(e)return r({candyRedv:"N/A"});let i=JSON.parse(s);return r({deviceId:t,candyRedv:i.version||"N/A"})})}))))}_setupExitHandler(){function e(e){console.log("[CANDY RED] Bye"),_nodeRed.default.settings&&_nodeRed.default.settings.exitHandlers&&_nodeRed.default.settings.exitHandlers.forEach(e=>{try{e(_nodeRed.default)}catch(e){console.log(`[CANDY RED] The error [${e}] is ignored`),console.log(`[CANDY RED] ${e.stack}`)}}),e instanceof Error?(console.log(e.stack),process.exit(1)):isNaN(e)?process.exit():process.exit(e)}process.stdin.resume(),process.on("SIGINT",e),process.on("uncaughtException",e),process.on("unhandledRejection",e=>{console.log("[CANDY RED] {FATAL} unhandledRejection",e)})}_createREDSettigngs(e){let t={flowFilePretty:!0,verbose:!0,disableEditor:!1,httpAdminRoot:"/red/",httpNodeRoot:"/api/",userDir:(process.env.CANDY_RED_HOME||process.env.HOME||process.env.USERPROFILE)+"/.node-red",flowFile:this.flowFile,functionGlobalContext:{},exitHandlers:[],nodesExcludes:[],deviceManager:this.deviceManager,editorTheme:this.editorTheme,candyRedVersion:e.candyRedv,deviceId:e.deviceId,logging:{console:{level:CANDY_RED_LOG_LEVEL,metrics:!1,audit:!1}}};if(this.deviceManager.initSettings(t),CANDY_RED_ADMIN_USER_ID&&CANDY_RED_ADMIN_PASSWORD_ENC){let e=new _auth.SingleUserAuthenticator(CANDY_RED_SESSION_TIMEOUT,CANDY_RED_ADMIN_USER_ID,CANDY_RED_ADMIN_PASSWORD_ENC);t.adminAuth=e.init(),this.app.use(t.httpNodeRoot,e.apiBasicAuthMiddleware.bind(e)),console.log(`[CANDY RED] Using the user:${CANDY_RED_ADMIN_USER_ID} credentials for authentication, session expires after ${CANDY_RED_SESSION_TIMEOUT} seconds`)}else if("production"===NODE_ENV){let e=new _auth.PAMAuthenticator(CANDY_RED_SESSION_TIMEOUT);t.adminAuth=e.init(),this.app.use(t.httpNodeRoot,e.apiBasicAuthMiddleware.bind(e)),console.log("[CANDY RED] Using PAM for authentication")}else console.log("[CANDY RED] Authentication is disabled");return t}}if(exports.CandyRed=CandyRed,require.main===module){let e=DEFAULT_PACKAGE_JSON;process.argv.length>2&&(e=process.argv[2]),new CandyRed(e).start().catch(e=>{console.error(e.stack),process.exit(1)})}
//# sourceMappingURL=index.js.map
