/**
 * @license
 * Copyright (c) 2020 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
"use strict";require("source-map-support/register");var _child_process=_interopRequireDefault(require("child_process")),_fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_events=require("events"),_serialport=_interopRequireDefault(require("serialport"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}module.exports=function(e){class t extends _events.EventEmitter{constructor(e={log:()=>{},trace:()=>{}}){super(),this.log=e.log?e.log.bind(e):console.log,this.trace=e.trace?e.trace.bind(e):console.log,this.output=null,this.name=null,this.runOnStartup=!1,this.runCommandTask=null,this.nmeaPortName=null,this.nmeaPort=null,this.initialized=!1,this.nodes=[]}init(){return this.initialized?Promise.resolve():(this.initialized=!0,this.loadGNSSConfig().then(()=>this.isEnabled()?(e.log.info("[CANDY RED] CANDY Pi Lite GNSS Client is enabled"),this.runOnStartup&&this.scheduleRunCommand(5e3),this.resolveNMEAPortName().then(e=>{this.nmeaPortName=e}).finally(()=>this.setupNMEAPort())):(e.log.info("[CANDY RED] CANDY Pi Lite GNSS Client is disabled"),Promise.resolve())))}scheduleRunCommand(t=2e3){this.runCommandTask&&clearTimeout(this.runCommandTask),this.runCommandTask=setTimeout(()=>{this.execute("start").then(e=>{0!==e.code&&this.scheduleRunCommand()}).catch(t=>{e.log.error(`[CANDY RED] <scheduleRunCommand> ${t.message||t}`),"ENOENT"!==t.code&&this.scheduleRunCommand(1e4)})},t)}resolveNMEAPortName(){return new Promise((e,t)=>{_fs.default.readdir("/dev",(s,i)=>{if(s)return t(s);let r=i.filter(e=>e.match("QWS.[A-Z0-9]*.NMEA"));return r.length<1?e(null):e(`/dev/${r[0]}`)})})}getNMEAPortName(){return this.nmeaPortName||e._("candy-pi-lite-gnss.nmeaPort.na")}isNMEASupported(){return!!this.nmeaPortName}setupNMEAPort(){return this.isNMEASupported()?(this.nmeaPort=new _serialport.default(this.nmeaPortName,{baudRate:9600,dataBits:8,parity:"none",stopBits:1},e=>{e?(this.emit("nmea-not-available"),setTimeout(()=>{this.setupNMEAPort()},5e3)):this.emit("nmea-available")}),this.nmeaPort.on("data",e=>{Buffer.from(e).toString().split("\n").map(e=>e.trim()).forEach(e=>{e&&this.emit("nmea",e)})}),this.nmeaPort.on("error",e=>{this.emit("nmea-error",e)})):(this.emit("nmea-not-available"),setTimeout(()=>{this.resolveNMEAPortName().finally(()=>{this.setupNMEAPort()})},5e3)),Promise.resolve()}createGNSSfilePath(){return _path.default.join(e.settings.userDir,"candy-pi-lite-gnss.json")}saveGNSSConfig(){return new Promise((t,s)=>{_fs.default.writeFile(this.createGNSSfilePath(),JSON.stringify({name:this.name,runOnStartup:this.runOnStartup}),t=>{if(t)return e.log.error(`[CANDY RED] <saveGNSSConfig> ${t} ${t.stack}`),s("[CANDY RED] <saveGNSSConfig> Failed to write GNSS config")})})}loadGNSSConfig(){return new Promise(e=>{_fs.default.readFile(this.createGNSSfilePath(),(t,s)=>{if(t)return e();try{let e=JSON.parse(s.toString());this.name=e.name,this.runOnStartup=e.runOnStartup}catch(e){}return e()})})}transform(e,t={}){let s=e;switch(s.name=this.name||"CANDY Pi Lite/+ GNSS",t.outformat){case"worldmap":s.lat=s.latitude,s.lon=s.longitude,s.speed=s.spkm,s.accuracy=s.hdop,s.bearing=(s.cog+180)%360,s.icon=t.icon,s.iconColor=t.iconColor,s.photoUrl=t.photoUrl,s.deleted=t.deleted,s.layer=t.layer,delete s.latitude,delete s.longitude,delete s.spkm,delete s.hdop,delete s.cog}return s}execute(t,s={}){return new Promise((i,r)=>{if(this.isExecuting())return r(e._("candy-pi-lite-gnss.errors.alreadyExecuting"));if(!t||t.indexOf(" ")>=0||"start stop status locate".indexOf(t)<0)return r(e._("candy-pi-lite-gnss.errors.unknownCommand",{cmd:t}));let n,o=["gnss",t,"--suspend","--resume"];switch(t){case"start":n="starting";break;case"stop":n="stopping";break;case"status":n="executing";break;case"locate":n="positioning",o.push("--format=2")}this.output="",this.cproc=_child_process.default.spawn("candy",o,{cwd:process.cwd(),env:process.env,stdio:["pipe","pipe","ignore"]}),this.emit(n),this.cproc.on("error",t=>(this.cproc=null,this.emit("ended"),this.emit("error"),"ENOENT"===t.code&&(t.message=e._("candy-pi-lite-gnss.errors.setupError")),r(t))),this.cproc.on("exit",e=>{this.log(`Command Done: pid => ${this.cproc.pid}, code => ${e}`),this.cproc=null;let r=this.output,n="";switch(n=0===e?"idle":"error",t){case"start":case"stop":break;case"status":try{r=JSON.parse(r).session}catch(e){}break;case"locate":if(n="error","Not fixed yet"===r)n="unfixed";else if(0===e)try{r=this.transform(JSON.parse(r),s),n="idle"}catch(e){}}let o={cmd:t,code:e,result:r};return this.emit(n),this.emit("ended",o),i(o)}),this.cproc.stdout.on("data",e=>{let s=e.toString().trim().replace(/[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/g,"");this.trace(`<stdout> cmd => [${t}], output => [${s}]`),this.output+=s})})}isExecuting(){return!!this.cproc}add(e){return e&&this.nodes.push(e),this.nodes}remove(e){try{if(e){this.nodes.indexOf(e)>=0&&this.nodes.splice(e,1)}return 0===this.nodes.length?this.shutdown():Promise.resolve()}catch(e){return Promise.reject(e)}}isEnabled(){return this.nodes.length>0}shutdown(){this.initialized=!1;let e=this.isExecuting();return new Promise(t=>{if(!e)return t();this.cproc.kill("SIGINT"),this.once("ended",()=>t())}).then(()=>new Promise(e=>{if(!this.nmeaPort||!this.nmeaPort.isOpen)return e();this.nmeaPort.once("close",()=>e()),this.nmeaPort.close(),this.nmeaPort=null}))}}const s=new t;let i=()=>{s.shutdown()};process.on("exit",i),e.settings&&e.settings.exitHandlers&&e.settings.exitHandlers.push(i);e.nodes.registerType("CANDY Pi Lite gnss in",class{constructor(t){e.nodes.createNode(this,t),this.icon=t.icon,this.iconColor=t.iconColor,this.photoUrl=t.photoUrl,this.layer=t.layer,this.deleted=!!t.deleted,this.outformat=t.outformat||"worldmap",["starting","stopping","executing"].forEach(e=>{s.on(e,()=>{this.status({fill:"blue",shape:"dot",text:`candy-pi-lite-gnss.status.${e}`})})}),["positioning"].forEach(e=>{s.on(e,()=>{this.status({fill:"green",shape:"dot",text:`candy-pi-lite-gnss.status.${e}`})})}),["idle","unfixed"].forEach(e=>{s.on(e,()=>{this.status({fill:"grey",shape:"ring",text:`candy-pi-lite-gnss.status.${e}`})})}),["error"].forEach(e=>{s.on(e,()=>{this.status({fill:"red",shape:"ring",text:`candy-pi-lite-gnss.status.${e}`})})}),s.add(this),this.on("close",e=>{s.remove(this).then(()=>{e()}).catch(t=>{e(t)})}),this.on("input",e=>{s.execute(e.topic,this).then(t=>{this.send({topic:e.topic,code:t.code,payload:t.result})}).catch(t=>{let s=t.payload?t:{payload:t,topic:e.topic};this.error("CANDY Pi Lite gnss in error",s)})})}});e.nodes.registerType("CANDY Pi Lite nmea in",class{constructor(t){e.nodes.createNode(this,t),["nmea-available"].forEach(e=>{s.on(e,()=>{this.status({fill:"green",shape:"dot",text:`candy-pi-lite-gnss.status.${e}`})})}),["error","nmea-error","nmea-not-available"].forEach(e=>{s.on(e,()=>{this.status({fill:"red",shape:"ring",text:`candy-pi-lite-gnss.status.${e}`})})}),s.on("nmea",e=>{this.send({topic:s.name,payload:e})}),s.on("nmea-error",e=>{let t=e.payload?e:{payload:e,topic:"nmea"};this.error("CANDY Pi Lite nmea in error",t)}),s.add(this),this.on("close",e=>{s.remove(this).then(()=>{e()}).catch(t=>{e(t)})})}}),e.httpAdmin.get("/candy-pi-lite-gnss",e.auth.needsPermission("candy-pi-lite-gnss.read"),(t,i)=>{s.resolveNMEAPortName().then(t=>{i.json({name:s.name,runOnStartup:s.runOnStartup,nmeaPort:t||e._("candy-pi-lite-gnss.nmeaPort.na")})})}),e.httpAdmin.post("/candy-pi-lite-gnss",e.auth.needsPermission("candy-pi-lite-gnss.write"),(e,t)=>{s.name=e.body.name,s.runOnStartup=e.body.runOnStartup,s.saveGNSSConfig().then(()=>{t.sendStatus(200)}).catch(()=>{t.sendStatus(500)})}),e.events.on("runtime-event",e=>{"runtime-state"===e.id&&s.init().then(()=>{s.emit("idle")})})};
//# sourceMappingURL=candy-pi-lite-gnss.js.map
